/***************************************************************************
 *   Copyright (C) 2004 by Spiros Georgaras                                *
 *   sngeorgaras@otenet.gr                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <klocale.h>
#include <kfiledialog.h>
#include <qlabel.h>
#include <qwidget.h>

#include "kmhtconvert.h"
#include "MHT.h"
#include "WAR.h"
#include "about.h"

//#define DEBUGING
//#define ONE_OPTION_ACTIVE
extern MHT mhtToWarFile;
extern QString fName;
extern bool viewOnly;
extern bool createMHT;
//iconload ic;

/*================================
	default constractor
================================*/
kmhtConvert::kmhtConvert(){
}
/*================================
	custom constractor
	
================================*/
kmhtConvert::kmhtConvert(const QString dir)
    : QWidget( 0, "kmhtConvert" ){
	delay=250;
	outputFolder=dir;
	setCaption("kmhtConvert - " + i18n("Web Archive Converter"));
	if(viewOnly){
		Form1Layout = new QVBoxLayout( this, 11, 6, "Form1Layout"); 
		lblCur = new QLabel( this, "lblCur" );
		lblCur->setText(i18n("Creating War file"));
		lblCur->setAlignment( int( QLabel::AlignCenter ) );
		Form1Layout->addWidget( lblCur );
		setFixedSize(292,68);
		QRect desktopSize=KGlobalSettings::splashScreenDesktopGeometry();
		move((desktopSize.right() - desktopSize.left() -292)/2,(desktopSize.bottom() - desktopSize.top() -68)/2);
		connect(&counter, SIGNAL(timeout()), this, SLOT(viewWar()));
		counter.start(100,TRUE);
	}else{
		// Added from ui generated cpp
		Form1Layout = new QVBoxLayout( this, 11, 6, "Form1Layout"); 
	
		groupBox1 = new QGroupBox( this, "groupBox1" );
		groupBox1->setColumnLayout(0, Qt::Vertical );
		groupBox1->layout()->setSpacing( 6 );
		groupBox1->layout()->setMargin( 11 );
		groupBox1Layout = new QHBoxLayout( groupBox1->layout() );
		groupBox1Layout->setAlignment( Qt::AlignTop );
	
		txtFile = new KLineEdit( groupBox1, "txtFile" );
		txtFile->setMinimumSize( QSize( 500, 0 ) );
		groupBox1Layout->addWidget( txtFile );
	
		cmbFile = new KPushButton( groupBox1, "cmbFile" );
		cmbFile->setMinimumSize( QSize( 30, 30 ) );
		cmbFile->setMaximumSize( QSize( 30, 32767 ) );
		groupBox1Layout->addWidget( cmbFile );
		Form1Layout->addWidget( groupBox1 );
	
		groupBox1_2 = new QGroupBox( this, "groupBox1_2" );
		groupBox1_2->setColumnLayout(0, Qt::Vertical );
		groupBox1_2->layout()->setSpacing( 6 );
		groupBox1_2->layout()->setMargin( 11 );
		groupBox1_2Layout = new QVBoxLayout( groupBox1_2->layout() );
		groupBox1_2Layout->setAlignment( Qt::AlignTop );
	
		layout2 = new QHBoxLayout( 0, 0, 6, "layout2"); 
				
		txtFolder = new KLineEdit( groupBox1_2, "txtFolder" );
		txtFolder->setMinimumSize( QSize( 500, 0 ) );
		layout2->addWidget( txtFolder );
	
		cmbFolder = new KPushButton( groupBox1_2, "cmbFolder" );
		cmbFolder->setMinimumSize( QSize( 30, 30 ) );
		cmbFolder->setMaximumSize( QSize( 30, 32767 ) );
		layout2->addWidget( cmbFolder );
		groupBox1_2Layout->addLayout( layout2 );
		Form1Layout->addWidget( groupBox1_2 );
	
		groupMHT = new QGroupBox( this, "groupMHT" );
		groupMHT->setColumnLayout(0, Qt::Vertical );
		groupMHT->layout()->setSpacing( 6 );
		groupMHT->layout()->setMargin( 11 );
		groupMHTLayout = new QVBoxLayout( groupMHT->layout() );
		groupMHTLayout->setAlignment( Qt::AlignTop );
	
		chkSave = new QCheckBox( groupMHT, "chkSave" );
		chkSave->setFocusPolicy( QWidget::StrongFocus );
		groupMHTLayout->addWidget( chkSave );
	
		chkView = new QCheckBox( groupMHT, "chkView" );
		chkView->setFocusPolicy( QWidget::StrongFocus );
		groupMHTLayout->addWidget( chkView );
		Form1Layout->addWidget( groupMHT );
	
		textLabel2 = new QLabel( this, "textLabel2" );
		Form1Layout->addWidget( textLabel2 );
	
		lstAction = new KListBox( this, "lstAction" );
		lstAction->setMinimumSize( QSize( 0, 150 ) );
		lstAction->setFocusPolicy( KListBox::NoFocus );
		Form1Layout->addWidget( lstAction );
	
		layout33 = new QHBoxLayout( 0, 0, 6, "layout33"); 
	
		cmbAbout = new KPushButton( this, "cmbAbout" );
		cmbAbout->setMinimumSize( QSize( 100, 0 ) );
		layout33->addWidget( cmbAbout );
		spacer1 = new QSpacerItem( 243, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
		layout33->addItem( spacer1 );
	
		cmbOk = new KPushButton( this, "cmbOk" );
		cmbOk->setMinimumSize( QSize( 100, 0 ) );
		cmbOk->setDefault( TRUE );
		layout33->addWidget( cmbOk );
				
		cmbCancel = new KPushButton( this, "cmbCancel" );
		cmbCancel->setMinimumSize( QSize( 100, 0 ) );
		cmbCancel->setAutoDefault( TRUE );
		layout33->addWidget( cmbCancel );
		Form1Layout->addLayout( layout33 );
		resize( QSize(0, 0).expandedTo(minimumSizeHint()) );
		clearWState( WState_Polished );
		// Strings and accel
		groupBox1->setTitle( i18n( "Input file" ) );
		cmbFile->setText( QString::null );
		cmbFile->setFocusPolicy( KPushButton::NoFocus );
		QToolTip::add( cmbFile, i18n( "Select Archive to convert" ) );
		groupBox1_2->setTitle( i18n( "Output folder" ) );
		cmbFolder->setText( QString::null );
		cmbFolder->setFocusPolicy( KPushButton::NoFocus );
		QToolTip::add( cmbFolder, i18n( "Select folder to save the converted file(s)" ) );
		groupMHT->setTitle( i18n( "Options" ) );
		chkSave->setText( i18n( "Only extract files" ) );
		QToolTip::add( chkSave, i18n( "Extract the files contained in the mht file\nNo KDE Web Archive will not be created" ) );
		chkView->setText( i18n( "View file after extraction" ) );
		QToolTip::add( chkView, i18n( "Display the extracted file in Konqueror" ) );
		textLabel2->setText( i18n( "Actions - Messages" ) );
		cmbAbout->setText( i18n( "&About" ) );
		//cmbAbout->setFocusPolicy( KPushButton::NoFocus );
		cmbAbout->setAccel( QKeySequence( i18n( "Alt+A" ) ) );
		cmbOk->setText( i18n( "&OK" ) );
		cmbOk->setAccel( QKeySequence( i18n( "Alt+O" ) ) );
		cmbCancel->setText( i18n( "&Cancel" ) );
		cmbCancel->setAccel( QKeySequence( i18n( "Alt+C" ) ) );
		// Added from ui generated cpp
		// signals and slots connections
		connect( cmbCancel, SIGNAL( clicked() ), this, SLOT( exitForm() ) );
		connect( cmbOk, SIGNAL( clicked() ), this, SLOT( convertIt() ) );
		connect( cmbFolder, SIGNAL( clicked() ), this, SLOT( getSaveFolder() ) );
		connect( cmbFile, SIGNAL( clicked() ), this, SLOT( getArchive() ) );
		connect( txtFile, SIGNAL(textChanged(const QString&)), this, SLOT(txtFolderChanged()));
		connect( txtFile, SIGNAL(returnPressed( const QString & )), cmbOk, SIGNAL( clicked()));
		connect( txtFolder, SIGNAL(returnPressed( const QString & )), cmbOk, SIGNAL( clicked()));
		#ifdef ONE_OPTION_ACTIVE
		connect( chkView,SIGNAL(stateChanged(int)),this, SLOT(chkViewstateChanged(int)));
		connect( chkSave,SIGNAL(stateChanged(int)),this, SLOT(chkSavestateChanged(int)));
		#endif
		//
		canConvert=TRUE;
		outputFileCerated=FALSE;
		canExit=TRUE;
		inputFile="";
		outputFolder=dir;
		txtFolder->setText(outputFolder);
		findMode(); 
		loadIcons();
		connect( cmbAbout, SIGNAL( clicked() ), this, SLOT(showAboutWindow()));
		cmbFile->setPixmap(ic->Icon(0));
		cmbFolder->setPixmap(ic->Icon(1));
		if(!fName.isEmpty()) txtFile->setText(fName);
		if(outputFolder.isEmpty()) outputFolder=defaultFolder();
		if(outputFolder.right(1)=="/"){
			QString tmpoutputFolder=outputFolder.left(outputFolder.length()-1);
			outputFolder=tmpoutputFolder;
		}
	}
}

kmhtConvert::~kmhtConvert(){}
//================================
//
//          MHT -> WAR
//
//================================
/*================================
================================*/
void kmhtConvert::loadIcons(){
ic=new iconload();
	QStringList picture("16x16/actions/filenew.png");
	if(ic->loadIcon(picture,0)==-1) iconLoadError("filenew.png");
	picture=QStringList("16x16/filesystems/folder.png");
	if(ic->loadIcon(picture,1)==-1) iconLoadError("folder.png");
	picture=QStringList("16x16/actions/ok.png");
	if(ic->loadIcon(picture,2)==-1) iconLoadError("ok.png");
	picture=QStringList("16x16/actions/cancel.png");
	if(ic->loadIcon(picture,3)==-1) iconLoadError("cancel.png");
	picture=QStringList("16x16/actions/info.png");
	if( ic->loadIcon(picture,4)==-1) iconLoadError("info.png"); 
	picture=QStringList("48x48/apps/kmhtconvert.png");
	if( ic->loadIcon(picture,5)==-1) iconLoadError("kmhtconvert.png"); 
}
/*================================
================================*/
void kmhtConvert::iconLoadError(QString str){
	lstAction->insertItem(ic->Icon(3),"Error loading icon: " + str);
}
/*================================
================================*/
QString kmhtConvert::defaultFolder(){
	int c=txtFile->text().findRev('/');
	return txtFile->text().left(c);
}
/*================================
================================*/
void kmhtConvert::findMode(){
	mode=0;
	groupMHT->setEnabled(TRUE);
	if(txtFile->text().right(4).lower()==".mht" || txtFile->text().right(6).lower()==".mhtml"){
		mode=1;
		QToolTip::add( chkSave, i18n( "Extract the files contained in the mht file\nNo KDE Web Archive will be created" ));
		QToolTip::add( chkView, i18n( "Display the extracted file in Konqueror" ));
	}else if(txtFile->text().right(6).lower()==".mhtml"){
		mode=1;
		QToolTip::add( chkSave, i18n( "Extract the files contained in the mhtml file\nNo KDE Web Archive will be created" ));
		QToolTip::add( chkView, i18n( "Display the extracted file in Konqueror" ));
	}else if(txtFile->text().right(4).lower()==".war"){
		mode=2;
		QToolTip::add( chkSave, QString::null);
		QToolTip::add( chkView, QString::null);
		groupMHT->setEnabled(FALSE);
	}
}
/*================================
================================*/
void kmhtConvert::getSaveFolder(){
	QString defFolder=txtFolder->text();
	if(defFolder.isEmpty()){
		if(txtFile->text().isEmpty()) defFolder=QString(getenv("HOME"));
		else{
			int sl=txtFile->text().findRev("/");
			if(sl!=-1) defFolder=txtFile->text().left(sl);
		}
	}
	QString newFolder=KFileDialog::getExistingDirectory(defFolder,this,QString(i18n("Select the location to save the output file")));
	if(!newFolder.isEmpty()){
		QFileInfo dirNewFolder(newFolder);
		if(!dirNewFolder.isWritable()){
			addMessageToList(3,i18n("You don't have write permission to folder \"%1\"").arg(newFolder));
		}else{
			outputFolder=newFolder;
			txtFolder->setText(newFolder);
		}
	}
	txtFolder->setFocus();
}
/*================================
================================*/
void kmhtConvert::addMessageToList(int pixId, QString message){
	lstAction->insertItem(ic->Icon(pixId),message);
	lstAction->setBottomItem(lstAction->count()-1);
}
/*================================
================================*/
void kmhtConvert::getArchive( ){
	QString defFolder=defaultFolder();
	if(defFolder.isEmpty()) defFolder=QString(getenv("HOME"));
	QString  fileFilter;
	if(mode==0) fileFilter="*.mht *.war | " + i18n("Web Archive") + " (*.mht,*.war)\n*.mht | " + i18n("Windows Web Archive") + " (*.mht)\n*.war | " + i18n("KDE Web Archive") + " (*.war)";
	else if(mode==1) fileFilter="*.mht | " + i18n("Windows Web Archive") + "  (*.mht)\n*.war | " + i18n("KDE Web Archive") + " (*.war)";
	else fileFilter="*.war | " + i18n("KDE Web Archive") + " (*.war)\n*.mht | " + i18n("Windows Web Archive") + " (*.mht)";
	QString tmpfName=KFileDialog::getOpenFileName(defFolder,fileFilter,this,i18n("Select Web Archive to convert"));
	if(!tmpfName.isEmpty()){
		QFileInfo tmpfNameInfo(tmpfName);
		if(!tmpfNameInfo.isReadable()){
			addMessageToList(3,i18n("You don't have read permission to file \"%1\"").arg(tmpfName));
			canConvert=FALSE;
		}else{
			inputFile=tmpfName;
			txtFile->setText(tmpfName);
			canConvert=TRUE;
			lstAction->clear();
			//findMode();
		}
	}
	txtFile->setFocus();
}
//================================
// Slots
//================================
/*================================
================================*/
void kmhtConvert::keyReleaseEvent ( QKeyEvent * e ){
	if(e->key()==Qt::Key_Enter || e->key()==Qt::Key_Return){
		if(cmbCancel->hasFocus()){
			e->accept();
			if(!justShowed) exitForm();
			else justShowed=FALSE;
		}else if (cmbAbout->hasFocus()){
			e->accept();
			if(!justShowed){
				justShowed=TRUE;
				showAboutWindow();
			}else justShowed=FALSE;
		}else{
			e->accept();
			justShowed=FALSE;
			convertIt();
		}
	}else if(e->key()==Qt::Key_Escape){
		e->accept();
		if(!justShowed) exitForm();
	}else{
		justShowed=FALSE;
		e->ignore();
	}
}
/*================================
================================*/
void kmhtConvert::exitForm(){
	if(canExit) close(TRUE);
}
/*================================
================================*/
void kmhtConvert::convertIt(){
	inputFile=txtFile->text();
	if(inputFile.isEmpty()) return;
	outputFolder=txtFolder->text();
	if(outputFolder.isEmpty()){
		int c=inputFile.findRev("/");
		if(c!=-1) outputFolder=inputFile.left(c);
	}
	if(!canConvert){
		bool okToExit=FALSE;
		if(inputFile==lastInputFile){
			if((outputFolder==lastOutputFolder) && outputFileCerated && (lastCreateFilesOnly==chkSave->isChecked()) && (lastViewAfterExtraction==chkView->isChecked())) okToExit=TRUE;
		}
		if(okToExit){
//			close(TRUE);
			lstAction->clear();
			addMessageToList(2,i18n("The file has already been converted"));
			return;
		}
	}
	QFileInfo tmpfNameInfo(inputFile);
	if(!tmpfNameInfo.exists()){
		lstAction->clear();
		addMessageToList(3,i18n("The input file does not exist"));
		saveLastState();
		return;
	}else if(!tmpfNameInfo.isReadable()){
		lstAction->clear();
		addMessageToList(3,i18n("You don't have read permission to file \"%1\"").arg(inputFile));
		saveLastState();
		return;
	}
	tmpfNameInfo.setFile(outputFolder);
	if(!tmpfNameInfo.exists()){
		lstAction->clear();
		addMessageToList(3,i18n("The ouput folder does not exist"));
		saveLastState();
		return;
	}else if(!tmpfNameInfo.isDir()){
		lstAction->clear();
		addMessageToList(3,i18n("Invalid output folder specified"));
		saveLastState();
		return;
	}else if(!tmpfNameInfo.isWritable()){
		lstAction->clear();
		addMessageToList(3,i18n("You don't have write permission to the output folder"));
		saveLastState();
		return;
	}
	if(lstAction->count()>0) //lstAction->insertItem(QString::null);
		lstAction->clear();
	findMode();
	if(mode==0){
		addMessageToList(3,i18n("File type not supported"));
		saveLastState();
		return;
	}else if(mode==1){
		//MHT --> WAR
		MHT* locMHT;
		locMHT=new MHT;
		connect( locMHT, SIGNAL (archiveOpened()), this, SLOT(slotFileOpened()));
		connect( locMHT, SIGNAL(foundFilesInArchive(int)), this, SLOT(slotFilesInArchive(int)));
		connect( locMHT, SIGNAL (fileExtraced(QString)), this, SLOT(slotExtractingFile(QString)));
		connect( locMHT, SIGNAL (archiveCreated(QString)), this, SLOT(slotOutputFileCreated(QString)));
		connect( locMHT, SIGNAL (errorAppeared(int)), this, SLOT(slotErrorAppeared(int)));
		if(chkSave->isChecked()) locMHT->setNoSaveWarFile(TRUE);
		if(!locMHT->setFile(inputFile,outputFolder)) return;
		if(!locMHT->extractAllFiles()) return;
		if(!chkSave->isChecked()) if(!locMHT->createWarArchive()) return;
		delete locMHT;
	}else{
		//WAR --> MHT
		WAR locWAR;
		connect( &locWAR, SIGNAL (archiveOpened()), this, SLOT(slotFileOpened()));
		connect( &locWAR, SIGNAL(foundFilesInArchive(int)), this, SLOT(slotFilesInArchive(int)));
		connect( &locWAR, SIGNAL (fileExtraced(QString)), this, SLOT(slotExtractingFile(QString)));
		connect( &locWAR, SIGNAL (archiveCreated(QString)), this, SLOT(slotOutputFileCreated(QString)));
		connect( &locWAR, SIGNAL (errorAppeared(int)), this, SLOT(slotErrorAppeared(int)));
		locWAR.setName(inputFile,outputFolder);
	}
}
/*================================
	called with
		emit archiveOpened();
================================*/
void kmhtConvert::slotFileOpened(){
	addMessageToList(2,i18n("Archive successfully opened"));
}
/*================================
	called with
		foundFilesInArchive([number of items]);
================================*/
void kmhtConvert::slotFilesInArchive(int num){
	addMessageToList(4,QString(i18n("Files in archive: ")) + QString("%1").arg(num));
}
/*================================
	called with
		emit fileExtraced([file name]);
================================*/
void kmhtConvert::slotExtractingFile(QString file){
	addMessageToList(4,QString(i18n("Extracting file: ")) + QString("%1").arg(file));
}
/*================================
	Called when the output file / files is created
	if MHT -> WAR (or save files only) show the
	output file in konqueror
================================*/
void kmhtConvert::slotOutputFileCreated(QString file){
	addMessageToList(2,i18n("Output file successfully created"));
	saveLastState();
	if(chkView->isChecked() && chkView->isEnabled()){
		if(chkSave->isChecked()) KRun::runURL("file:" + file + "/index.html","text/html",FALSE);
		else KRun::runURL("tar:" + file + "/index.html","text/html",FALSE);
	}
}
/*================================
	Add error messages to the list
	
	called with
		emit errorAppeared([error code]);
================================*/
void kmhtConvert::slotErrorAppeared(int err){
	QString msg;
	switch(err){
	case 1:
		msg=i18n(QString("Error opening input file"));
		;;
	case 2:
	case 3:
		msg=i18n(QString("File is corrupt"));
		break;;
	case 4:
		msg=i18n(QString("File type not supported"));
		break;;
	case 5:
		msg=i18n(QString("Error extracting file"));
		break;;
	case 6:
		msg=i18n(QString("Error opening output file"));
		;;
	}
	addMessageToList(3,msg);
	saveLastState(); // FIX ?
}
/*================================
================================*/
void kmhtConvert::txtFolderChanged( ){
	findMode();
	if(mode==1) mhtToWarFile.reset();
}
/*================================
	show about window
================================*/
void kmhtConvert::showAboutWindow(){
	justShowed=TRUE;
	cmbAbout->setFocus();
	aboutMhtConvert* abMHT=new aboutMhtConvert(ic->Icon(5));
	abMHT->show();
}
/*================================
================================*/
void kmhtConvert::chkViewstateChanged(int status){
	if(status==2) chkSave->setChecked(FALSE);
}
/*================================
================================*/
void kmhtConvert::chkSavestateChanged(int status){
	if(status==2) chkView->setChecked(FALSE);
}
/*================================
	saves the state of last execution
================================*/
void kmhtConvert::saveLastState(){
	canConvert=FALSE;
	outputFileCerated=TRUE;
	lastInputFile=inputFile;
	lastOutputFolder=outputFolder;
	lastCreateFilesOnly=chkSave->isChecked();
	lastViewAfterExtraction=chkView->isChecked();
}
/*================================
================================*/
void kmhtConvert::keyPressEvent( QKeyEvent *e ){
if(e->key()==Qt::Key_Escape && e->state()==Qt::NoButton && cmbOk->isEnabled()) close(TRUE);
}
/*================================
================================*/
void kmhtConvert::viewWar(){
			counter.stop();
// 		prog->setProgress(30);
// 		lblCur->update();update();
		mhtToWarFile.setFile(fName);
		//close(TRUE); // test case
		if(mhtToWarFile.status==1){
			hide();
			KMessageBox::error(0,i18n(QString("Error opening file")),0);
			close(TRUE);
		}else if(mhtToWarFile.status==2 || mhtToWarFile.status==3){
			hide();
			KMessageBox::error(0,i18n(QString("File is corrupt")),0);
			close(TRUE);
		}else if(mhtToWarFile.status==4){
			hide();
			KMessageBox::error(0,i18n(QString("File type not supported")),0);
			close(TRUE);
		}
		//close(TRUE); // test case
		if(!mhtToWarFile.extractAllFiles()){
			hide();
			KMessageBox::error(0,i18n(QString("Error extracting files")),0);
			close(TRUE);
		}
		if(!mhtToWarFile.createWarArchive()){
			hide();
			KMessageBox::error(0,i18n(QString("Error creating output war file")),0);
			close(TRUE);
		}
		mhtToWarFile.showWarFile();
		close(TRUE);
}
#include "kmhtconvert.moc"
