/***************************************************************************
 *   Copyright (C) 2004 by Spiros Georgaras                                *
 *   sngeorgaras@otenet.gr                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <iostream>
#include "kmhtconvert.h"
#include <kapplication.h>
#include <kaboutdata.h>
#include <kcmdlineargs.h>
#include <klocale.h>
#include <kmessagebox.h>
#include <kmimetype.h>
#include <ksharedptr.h> 
#include <ktar.h>

#include <qobject.h>
#include <qfileinfo.h>

#include "MHT.h"
#include "WAR.h"
static const char description[] =I18N_NOOP("A Web Archive Converter");

static const char version[] = "0.6";

static KCmdLineOptions options[] =
{
	{"n",0,0},
	{"NoGui",I18N_NOOP("Execute without the GUI"), 0},
	{"s",0,0},
	{"silent",I18N_NOOP("Only report errors when executed without the GUI"), 0},
	{"f",0,0},
	{"onlyFiles",I18N_NOOP("Create a folder containing the files. Don't Create War file"), 0},
	{"w",0,0},
	{"viewWar",I18N_NOOP("Create War file in tmp folder and view it in Konqueror"), 0},
	{ "d <folder>", I18N_NOOP("Folder to save the output file"), 0 },
	{ "+[file]", I18N_NOOP( "MHT/War file to convert" ), 0 },
	KCmdLineLastOption
};
MHT mhtToWarFile;
bool silent;
bool useGui;
bool onlyFile;
bool viewOnly;
//bool createMHT;
QString fName;
KAboutData* ab;
kmhtConvert* ptrMainWindow=0;

int main(int argc, char **argv)
{
	QString dummy1=i18n("Convert to KDE Web Archive");
	QString dummy2=i18n("Convert to Windows Web Archive");
	bool createMHT=FALSE;
	fName="";
	KAboutData about("kmhtconvert", I18N_NOOP("kmhtConvert"), version, description,
		KAboutData::License_GPL, "(C) 2004 Spiros Georgaras", 0, "http://users.otenet.gr/~geosp/kmhtconvert/", "sngeorgaras@otenet.gr");
	about.addAuthor( "Spiros Georgaras", 0, "sngeorgaras@otenet.gr" );
	ab=&about;
	KCmdLineArgs::init(argc, argv, &about);
	KCmdLineArgs::addCmdLineOptions( options );

	KApplication app;
/*
			int accuracy1=0;
			KMimeType::Ptr mt1 = KMimeType::findByFileContent("/d/fun/Belonaki.war" , &accuracy1 );
			std::cout << mt1->name() << std::endl;
			return 0;
*/


// 	QCString a[2];
// 	a[0].sprintf("%c",10);
// 	a[1]="";
// 	kdDebug()<< "a[0] isNull=" << a[0].isNull() << ", isEmpty=" << a[0].isEmpty() << endl;
// 	kdDebug()<< "a[1] isNull=" << a[1].isNull() << ", isEmpty=" << a[1].isEmpty() << endl;
// 	// result is
// 	//		kmhtconvert: a[0] isNull=false, isEmpty=false
// 	//		kmhtconvert: a[1] isNull=false, isEmpty=true
// 
// 	return 0;
	
	
	kmhtConvert *mainWin = 0;
	silent=FALSE;
	useGui=TRUE;
	onlyFile=FALSE;
	viewOnly=FALSE;
//	createMHT=FALSE;
	//QString fName("");
	QString outDir("");
	KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
	if(args->isSet("onlyFiles")){
		onlyFile=TRUE;
		mhtToWarFile.setNoSaveWarFile(TRUE);
	}
	if(args->isSet("silent")) silent=TRUE;
	if(args->isSet("NoGui")) useGui=FALSE;
//	if(args->isSet("reverse")) createMHT=TRUE;
	if(args->isSet("viewWar")){
		viewOnly=TRUE;
		mhtToWarFile.setViewWarFile(TRUE);
	}
	//if(!silent && !useGui) std::cout << "kmhtConvert v " << version << " -   2004 S. Georgaras <sngeorgaras@otenet.gr>" << std::endl<< std::endl;
	if(args->count()>0){
		fName=args->url(0).path();
		if( (viewOnly && (!useGui || onlyFile || args->isSet("d"))) ||
				(createMHT && (onlyFile || viewOnly)) ){
			if(!useGui)std::cout << "Conflicting command line parameters used..." << std::endl;
			else KMessageBox::error(0,i18n(QString("Conflicting command line parameters used...")),0);
			args->clear();
			return 1;
		}
		QFileInfo ff(fName);
		if(!ff.exists()){
			if(useGui){
				KMessageBox::error(0,i18n(QString("The input file does not exist")),0);
				args->clear();
				return 1;
			}else{
				std::cout << i18n(QString("The input file does not exist")) << std::endl;
				args->clear();
				return 1;
			}
		}else{
			if(fName.right(4).lower()==".war") createMHT=TRUE;
			else if (fName.right(4).lower()==".mht") createMHT=FALSE;
			else{
				if(!useGui)std::cout << "The input file is neither a KDE nor a Windows Web Archive..." << std::endl;
				else KMessageBox::error(0,i18n(QString("The input file is neither a KDE nor a Windows Web Archive...")),0);
				args->clear();
				return 1;
			}
			if(!ff.isReadable()){
				if(useGui) KMessageBox::error(0,i18n(QString("You don't have read permission to the input file")),0);
				else std::cout << i18n(QString("You don't have read permission to the input file")) << std::endl;
				args->clear();
				return 1;
			}
		}
		int accuracy=0;
		if(createMHT){
			KMimeType::Ptr mt = KMimeType::findByFileContent(fName , &accuracy );
			if(!mt->is("application/x-gzip") || !(fName.mid(fName.length()-4).lower()==".war")){
				if(useGui){
					KMessageBox::error(0,i18n(QString("The input file is not a KDE Web Archive")),0);
				}else{
					std::cout <<i18n(QString("The input file is not a KDE Web Archive")) << std::endl;
				}
				args->clear();
				return 1;
			}
		}else{
			KMimeType::Ptr mt = KMimeType::findByFileContent(fName , &accuracy );
			//kdDebug() << "mime type = " << mt->name() << endl;
// To be restored in normal tarball
// 			if(!mt->is("message/rfc822")){
// 				if(useGui){
// 					KMessageBox::error(0,i18n(QString("The input file is not a mail message (message/rfc822)")),0);
// 				}else{
// 					std::cout <<i18n(QString("The input file is not a mail message (message/rfc822)")) << std::endl;
// 				}
// 				args->clear();
// 				return 1;
// 			}
			if(!(fName.mid(fName.length()-4)==".mht" || fName.mid(fName.length()-4)==".MHT")){
				if(useGui){
					KMessageBox::error(0,i18n(QString("The input file is a mail message (message/rfc822), but not a Windows Web Archive")),0);
				}else{
					std::cout <<i18n(QString("The input file is a mail message (message/rfc822), but not a Windows Web Archive")) << std::endl;
				}
				args->clear();
				return 1;
			}
		}
	}else{
		if(!useGui){
			std::cout << i18n("No input file specified") << std::endl;
			args->clear();
			return 1;
		}else{
			if(viewOnly){
				KMessageBox::error(0,i18n(QString("No input file specified")),0);
				args->clear();
				return 1;
			}
		}
	}
	if(args->isSet("d")){
		//outDir = QString::fromUtf8(args->getOption("d"));
		outDir = args->getOption("d");
		QFileInfo mFile(outDir);
		if(!mFile.exists()){
			if(useGui){
				KMessageBox::error(0,i18n(QString("The ouput folder does not exist")),0);
				outDir=QString("");
			}else{
				std::cout << i18n(QString("The ouput folder does not exist")) << std::endl;
				args->clear();
				return 1;
			}
		}else if(!mFile.isDir()){
			if(useGui){
				KMessageBox::error(0,i18n(QString("Invalid output folder specified ")),0);
				outDir=QString("");
			}else{
				std::cout << i18n(QString("Invalid output folder specified")) << std::endl;
				args->clear();
				return 1;
			}
		}else if(!mFile.isWritable()){
			if(useGui){
				KMessageBox::error(0,i18n(QString("You don't have write permission to the output folder")),0);
				outDir=QString("");
			}else{
				std::cout << i18n(QString("You don't have write permission ot the output folder")) << std::endl;
				args->clear();
				return 1;
			}
		}
	}
	args->clear();
	if(!useGui){
		if(!silent) std::cout << i18n(QString("Input file: ")) ;
		QString fnametodisplay;
		int c=fName.findRev('/');
		fnametodisplay=fName.mid(c+1);
		if(!silent) std::cout << fnametodisplay << std::endl;
		if(createMHT){
			// War --> mht
			WAR warToMhtFile;
			warToMhtFile.setName(fName,outDir,silent,useGui);
			//return 0;
		}else{
			// mht --> War
			MHT* m;
			m=new MHT;
			m->setSilent(silent);
			m->setUseGui(useGui);
			m->setFile(fName, outDir);
			//return 0; // test case
			if(m->status==1){
				std::cout << i18n(QString("Error opening file")) << std::endl;
				return 1;
			}else if(m->status==2 || m->status==3){
				std::cout << i18n(QString("File is corrupt")) << std::endl;
				return 1;
			}else if(m->status==4){
				std::cout << i18n(QString("File type not supported")) << std::endl;
				return 1;
			}
			//std::cout << "Boundary = " << m->boundary << std::endl;
			if(!silent){
				QString oName;
				int u=-1;
				while((u=fName.find("/",u+1))!=-1) oName=fName.mid(u+1);
				if(!silent && !onlyFile) std::cout << i18n(QString("Files in archive: ")) << m->items() << std::endl;
			}
			if(!m->extractAllFiles()){
				if(silent) std::cout << i18n(QString("Error extracting file")) << std::endl;
				else std::cout << std::endl << i18n(QString("Error extracting file")) << std::endl;
				return 1;
			}
			if(!silent && !onlyFile) std::cout << i18n(QString("Creating output file"))<< " .... ";
			if(!onlyFile) if(!m->createWarArchive()){
				if(silent) std::cout << i18n(QString("Error creating output file")) << std::endl;
				else std::cout << std::endl << i18n(QString("Error creating output file")) << std::endl;
				return 1;
			}
			if(!silent && !onlyFile) std::cout << i18n(QString("done")) << std::endl << std::endl;
			return 0;
// 			mhtToWarFile.setSilent(silent);
// 			mhtToWarFile.setUseGui(useGui);
// 			mhtToWarFile.setFile(fName, outDir);
// 			//return 0; // test case
// 			if(mhtToWarFile.status==1){
// 				std::cout << i18n(QString("Error opening file")) << std::endl;
// 				return 1;
// 			}else if(mhtToWarFile.status==2 || mhtToWarFile.status==3){
// 				std::cout << i18n(QString("File is corrupt")) << std::endl;
// 				return 1;
// 			}else if(mhtToWarFile.status==4){
// 				std::cout << i18n(QString("File type not supported")) << std::endl;
// 				return 1;
// 			}
// 			//std::cout << "Boundary = " << mhtToWarFile.boundary << std::endl;
// 			if(!silent){
// 				QString oName;
// 				int u=-1;
// 				while((u=fName.find("/",u+1))!=-1) oName=fName.mid(u+1);
// 				if(!silent && !onlyFile) std::cout << i18n(QString("Files in archive: ")) << mhtToWarFile.items() << std::endl;
// 			}
// 			if(!mhtToWarFile.extractAllFiles()){
// 				if(silent) std::cout << i18n(QString("Error extracting file")) << std::endl;
// 				else std::cout << std::endl << i18n(QString("Error extracting file")) << std::endl;
// 				return 1;
// 			}
// 			if(!silent && !onlyFile) std::cout << i18n(QString("Creating output file"))<< " .... ";
// 			if(!onlyFile) if(!mhtToWarFile.createWarArchive()){
// 				if(silent) std::cout << i18n(QString("Error creating output file")) << std::endl;
// 				else std::cout << std::endl << i18n(QString("Error creating output file")) << std::endl;
// 				return 1;
// 			}
// 			if(!silent && !onlyFile) std::cout << i18n(QString("done")) << std::endl << std::endl;
// 			return 0;
		}
	}
	mainWin = new kmhtConvert(outDir);
	app.setMainWidget( mainWin );
	if(onlyFile) mainWin->chkSave->setChecked(TRUE);
	//if(viewOnly) mainWin->chkView->setChecked(TRUE);
	mainWin->show();
	args->clear();
	return app.exec();
}
